Summary:	musl libc - new standard library to power a new generation of Linux-based devices
Summary(pl.UTF-8):	musl libc - nowa biblioteka standardowa dla urządzeń linuksowych nowej generacji
Name:		musl
Version:	1.2.5
Release:	1
License:	MIT
Group:		Libraries
Source0:	https://www.musl-libc.org/releases/%{name}-%{version}.tar.gz
# Source0-md5:	ac5cfde7718d0547e224247ccfe59f18
Patch0:		%{name}-gcc.patch
URL:		http://www.musl-libc.org/
BuildRequires:	gcc >= 5:3.2
BuildRequires:	rpmbuild(macros) >= 2.007
BuildRequires:	zlib-devel
Requires:	uname(release) >= 2.6.0
ExclusiveArch:	%{ix86} %{x8664} x32 %{arm} aarch64 loongarch64 mips microblaze ppc riscv32
ExcludeArch:	i386
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_libdir		%{_prefix}/%{_lib}/musl
%define		_includedir	%{_prefix}/include/musl
%define		_fortify_cflags	%{nil}
%define		_ssp_cflags	%{nil}

%ifarch x32
%define		musl_arch	x32
%endif
%ifarch %{arm32_with_hf}
%define		musl_arch	armhf
%endif
%ifnarch x32 %{arm32_with_hf}
%define		musl_arch	%{_target_base_arch}
%endif

%description
musl libc is a new standard library to power a new generation of
Linux-based devices. It is lightweight, fast, simple, free, and
strives to be correct in the sense of standards-conformance and
safety.

musl is an alternative to glibc, uClibc, dietlibc, and klibc.

%description -l pl.UTF-8
musl libc to nowa biblioteka standardowa, przeznaczona do zasilania
urządzeń linuksowych nowej generacji. Jest lekka, szybka, prosta,
wolnodostępna i stara się być poprawna w sensie zgodności ze
standardami i bezpieczeństwa.

musl jest alternatywą dla bibliotek glibc, uClibc, dietlibc i klibc.

%package devel
Summary:	Development files for musl libc
Summary(pl.UTF-8):	Pliki programistyczne biblioteki musl libc
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Development files for musl libc.

%description devel -l pl.UTF-8
Pliki programistyczne biblioteki musl libc.

%prep
%setup -q
%patch0 -p1

%build
%configure \
	--syslibdir=/%{_lib}

# WRAPCC_GCC that will be used as $REALGCC fallback in musl-gcc script
# regardless what is value when this package is built (ccache, etc)
%{__make} \
	WRAPCC_GCC="%{_target_platform}-gcc"

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# move actual library to /lib to handle /usr mounts
mv $RPM_BUILD_ROOT{%{_libdir}/libc.so,/%{_lib}/ld-musl-%{musl_arch}.so.1}
ln -s /%{_lib}/ld-musl-%{musl_arch}.so.1 $RPM_BUILD_ROOT%{_libdir}/libc.so

install -d $RPM_BUILD_ROOT%{_sysconfdir}
echo '%{_libdir}' > $RPM_BUILD_ROOT%{_sysconfdir}/ld-musl-%{musl_arch}.path

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc COPYRIGHT INSTALL README WHATSNEW
%attr(755,root,root) /%{_lib}/ld-musl-%{musl_arch}.so.1
%dir %{_libdir}
%attr(755,root,root) %{_libdir}/libc.so
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/ld-musl-%{musl_arch}.path

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/musl-gcc
%{_libdir}/libc.a
# empty stubs
%{_libdir}/libcrypt.a
%{_libdir}/libdl.a
%{_libdir}/libm.a
%{_libdir}/libpthread.a
%{_libdir}/libresolv.a
%{_libdir}/librt.a
%{_libdir}/libutil.a
%{_libdir}/libxnet.a
# crts
%{_libdir}/Scrt1.o
%{_libdir}/crt*.o
%{_libdir}/rcrt1.o
%{_libdir}/musl-gcc.specs
%{_includedir}
%changelog
* Sun Mar 17 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/musl.git;a=log;h=master

* Sun Mar 17 2024 Jakub Bogusz <qboosh@pld-linux.org> a28fd13
- updated to 1.2.5

* Thu May 04 2023 Jan Palus <atler@pld-linux.org> b890369
- up to 1.2.4

* Wed Jun 15 2022 Jan Palus <atler@pld-linux.org> 6c06972
- updated source url to https

* Wed Jun 15 2022 Jan Palus <atler@pld-linux.org> 3299fac
- customize musl_arch for armhf

* Wed Jun 15 2022 Jan Palus <atler@pld-linux.org> 77b86a3
- use arm macro; add aarch64 to supported archs

* Wed Jun 15 2022 Arkadiusz Miśkiewicz <arekm@maven.pl> 05713c5
- Up to 1.2.3.

* Wed Apr 10 2019 Adam Gołębiowski <adamg@pld-linux.org> 40f0fc2
- updated to 1.1.22

* Tue Jan 03 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 88f43c0
- up to 1.1.16; fixes CVE-2016-8859

* Sun Sep 18 2016 Elan Ruusamäe <glen@delfi.ee> d8f773e
- add patch for b5db195

* Sun Sep 18 2016 Elan Ruusamäe <glen@delfi.ee> 2628abb
- override WRAPCC_GCC

* Sun Sep 18 2016 Elan Ruusamäe <glen@delfi.ee> b5db195
- musl-gcc: do not quote $REALGCC

* Thu Sep 01 2016 Elan Ruusamäe <glen@delfi.ee> 71c3252
- keep /%{_lib}/ld-musl-%{musl_arch}.so.1 as file

* Thu Sep 01 2016 Elan Ruusamäe <glen@delfi.ee> cb4531f
- 1.1.15 - July 5, 2016

* Sun Mar 06 2016 Jakub Bogusz <qboosh@pld-linux.org> 10ed8c2
- updated to 1.1.14
- removed obsolete locale patch

* Sun Jun 28 2015 Jan Rękorajski <baggins@pld-linux.org> abe77ff
- release 2 (by relup.sh)

* Tue Jun 23 2015 Jakub Bogusz <qboosh@pld-linux.org> 8717f06
- simplified musl_arch setting

* Tue Jun 16 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 437e273
- build on x32, too

* Tue Jun 16 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 29555da
- and one more upstream fix

* Tue Jun 16 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> c6997d0
- up to 1.1.10

* Sun Mar 09 2014 Jakub Bogusz <qboosh@pld-linux.org> 71b5741
- new URLs, updated to 0.9.15

